<?php

namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

class AprovacaoAlcadasService
{
    public function __construct($connection)
    {
        $this->connection           = $connection;
    }

    public function getAlcadas($conditions)
    {
        $sql = "SELECT NRAPROVALCADA, NRCONFIGALCADA, NMALCADA, IDTIPOVRAPROV, CDFILDEST, CDFILLANC,
                       NRDEMANDA, IDTPDEMANDA, IDCLASSIFIC, IDAPROVADO, DTINCLUSAO, APROVADOR,
                       VRAPROVCMP, NMFILDEST, VRTOTALAF, DSMOTVAFALCADA, NRINSJURFORN, NMRAZSOCFORN,
                       NMFANTFORN, NRORG, DTPROGENTAF, NVL(VRORCAMENTO, 0) VRORCAMENTO, 
                       NVL(VRREALIZADO, 0) VRREALIZADO, NVL(VRDIFERENCA, 0) VRDIFERENCA, IDEXIGJUSTIFICATIVA
                  FROM TABLE(APROVA_ALCADAS(P_CDFILIAL        => :P_CDFILIAL,
                                            P_CDOPERADOR      => :P_CDOPERADOR,
                                            P_IDAPROVADO      => :P_IDAPROVADO,
                                            P_IDCLASSIFIC     => :P_IDCLASSIFIC,
                                            P_NRCONFIGALCADA  => :P_NRCONFIGALCADA,
                                            P_DTINCLUSAO_INI  => :P_DTINCLUSAO_INI,
                                            P_DTINCLUSAO_FIN  => :P_DTINCLUSAO_FIN,
                                            P_TDTINCLUSAO     => :P_TDTINCLUSAO,
                                            P_DTENTREGAAF_INI => :P_DTENTREGAAF_INI,
                                            P_DTENTREGAAF_FIN => :P_DTENTREGAAF_FIN,
                                            P_TDTENTREGAAF    => :P_TDTENTREGAAF))";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute(
                array(
                    'P_CDFILIAL'        => $conditions['CDFILIAL'],
                    'P_CDOPERADOR'      => $conditions['CDOPERADOR'],
                    'P_IDAPROVADO'      => $conditions['IDAPROVADO'],
                    'P_IDCLASSIFIC'     => $conditions['IDCLASSIFIC'],
                    'P_NRCONFIGALCADA'  => $conditions['NRCONFIGALCADA'],
                    'P_DTINCLUSAO_INI'  => $conditions['P_DTINCLUSAO_INI'],
                    'P_DTINCLUSAO_FIN'  => $conditions['P_DTINCLUSAO_FIN'],
                    'P_TDTINCLUSAO'     => $conditions['P_TDTINCLUSAO'],
                    'P_DTENTREGAAF_INI' => $conditions['P_DTENTREGAAF_INI'],
                    'P_DTENTREGAAF_FIN' => $conditions['P_DTENTREGAAF_FIN'],
                    'P_TDTENTREGAAF'    => $conditions['P_TDTENTREGAAF'],
                )
            );

            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function defineColumn($IDAPROVADO)
    {
        if ($IDAPROVADO == 'PENDENTE')
            return 1;
        else if ($IDAPROVADO == 'APROVADO')
            return 2;
        else if ($IDAPROVADO == 'RECUSADO')
            return 3;
    }
}
